/*
 * kgraft_patch_bsc1025254
 *
 * Fix for bsc#1025254
 *
 *  Copyright (c) 2016 SUSE
 *  Author: Miroslav Benes <mbenes@suse.cz>
 *
 *  Based on the original Linux kernel code. Other copyrights apply.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <linux/kernel.h>
#include <linux/module.h>

#include "local.h"

/* patched function */
void kgr_wait_barrier(struct r1conf *conf)
{
	atomic_inc(&conf->nr_pending);
	/*
	 * Fix bsc#1025254
	 *  -if (atomic_read(&conf->barrier)) {
	 *  +1 line
	 */
	if (1) {
		spin_lock_irq(&conf->resync_lock);
		atomic_inc(&conf->nr_waiting);
		atomic_dec(&conf->nr_pending);
		/* Wait for the barrier to drop.
		 * However if there are already pending
		 * requests (preventing the barrier from
		 * rising completely), and the
		 * pre-process bio queue isn't empty,
		 * then don't wait, as we need to empty
		 * that queue to get the nr_pending
		 * count down.
		 */
		wait_event_lock_irq(
			conf->wait_barrier,
			!test_bit(R1FLAG_ARRAY_FROZEN, &conf->flags) &&
			/*
			 * Fix bsc#1025254
			 *  -(atomic_read(&conf->barrier) ||
			 *  +1 line
			 */
			(!atomic_read(&conf->barrier) ||
			 (atomic_read(&conf->nr_pending) &&
			 current->bio_list &&
			 !bio_list_empty(current->bio_list))),
			conf->resync_lock);
		atomic_inc(&conf->nr_pending);
		atomic_dec(&conf->nr_waiting);
		spin_unlock_irq(&conf->resync_lock);
	}
}
